/* Include file for c2html by Ankit Rohatgi <http://on.to/ank>
 * This code is absolutely free for use, distribution, modification, 
 * appreciation, critisism.
 *
 * Please keep me informed of any bugs or inefficiency.
 * 
 * Highlighting styles can be created in styles.c2h file.
 * 
 * Mon Feb 25 03:08:40 IST 2002
 * Editor Used: VIM (Vi- Improved) <http://www.vim.org>
 */ 

/* NOTE: To remove the hilarious comments before the <body> tag and
 * after </html> simply delete lines: 333 to 335 and 345
 * 
 */ 

#include<fstream.h>
#include<string.h>
#include<stdio.h>
#include<ctype.h>
#include<stdlib.h>
//****** number of *********
int TYPES; 
int STATEMENTS; 
//****** types ************
#define T_NORMAL 0
#define T_TYPES 1
#define T_SYMBOLS 3
#define T_STATEMENTS 2
#define T_PREPROC 4
#define T_CONSTANT 5
#define T_STRING 6
#define T_COMMENT 7

// keep last one empty.. used for counting !
// Add or remove as u wish...
char *datatypes[]={"char","int","long","float","double","bool","void",
                   "enum","unsigned","signed","short","const","static",
                   "typedef","class","register","namespace","volatile",
                   "template","extern","union","struct","auto","explicit",
                   "mutable","typename","inline","virtual",""};
char symbols[]="+-/*<>/|=!~%&:;,.[]{}()^?";
char *statements[]={"goto","break","continue","return","throw"
                    "switch","case","default","if","else","do","while",
                    "for","goto","new","operator","typeid","reinterpret_cast",
                    "static_cast","using","delete","dynamic_cast","this",
                    "false","friend","public","sizeof","try","protected",
                    "true","catch","private","const_cast",""};
	
					



// contains functions for writing HTML code.
class writecode
{ ofstream fl;
  public:
  void open(char *filename)
  { fl.open(filename); 
	if(!fl) {cout<<"Cannot write to: "<<filename; exit(1);}  
  }
  void filter(char w[],char str[]);
  void put_word(char w[],int type);
  void put_char(char ch);
  void pagebegin();
  void pageend();
  ~writecode()
  {  fl.close(); }
};

//functions for reading C/C++ code and sending to writecode members.
class readcode
{
	ifstream fl;
	writecode wc;

	public:
	void open(char *filein,char *fileout)
	{ fl.open(filein); 
	  if(!fl) { cout<<"Cannot read :"<<filein; exit(1); }	
	  wc.open(fileout);	
	}
	int issymbol(char ch);
	void get_comment_line(char str[]);
	void get_comment_block(char str[]);
	void  get_preproc_line(char str[]);
	char get_symbol_string(char str[],char f);
    char get_constant(char str[],char f);
	void get_string(char str[]);
	char get_word(char w[],char f);
	int matchtype(char *w);
	void reader();
	~readcode()
	{  fl.close(); }
};

//************ reader() **********
void readcode::reader()
{   
	wc.pagebegin();
	char temp[1024],ch=fl.get();; int carry=0;
	while(!fl.eof()) {
	
	if(ch=='/') // look for comments
	{ 
		ch=fl.get();
		if(ch=='/')
		{ 
			get_comment_line(temp);
			wc.put_word(temp,T_COMMENT);
			wc.put_char('\n');
		}
	    else if(ch=='*')
		{ 
			get_comment_block(temp);
			wc.put_word(temp,T_COMMENT);
		}
		else
		{ 
		    ch=get_symbol_string(temp,ch);
			wc.put_word(temp,T_SYMBOLS); carry=1;	
		}
		
	}
	else if(issymbol(ch)) // look for symbols
	{   
	    ch=get_symbol_string(temp,ch);
		wc.put_word(temp,T_SYMBOLS);	
		carry=1;
 	
	}
	else if(ch=='#') // look for preprocessors
	{   
		get_preproc_line(temp);
		wc.put_word(temp,T_PREPROC);
		wc.put_char('\n');
	}
	else if(ch==' '||ch=='\n'||ch=='\t') // space or \n
	{   wc.put_char(ch); }
	else if(ch=='"')
	{
		get_string(temp);
		wc.put_word(temp,T_STRING);
	}
	else if(isdigit(ch))
	{
		ch=get_constant(temp,ch); 
		wc.put_word(temp,T_CONSTANT); carry=1;
	}
    else if(ch=='\'')
	{
		char cht[2]; cht[1]='\0'; strcpy(temp,"\'"); cht[0]=fl.get();
		while(cht[0]!='\'')
		{
			strcat(temp,cht);
			if(cht[0]=='\\')
			{
				cht[0]=fl.get();
				strcat(temp,cht);
			}
			cht[0]=fl.get();
		}
		strcat(temp,"\'");
		wc.put_word(temp,T_STRING);
	}	
	else
	{    
	    ch=get_word(temp,ch);
		wc.put_word(temp,matchtype(temp));
		carry=1;
		
	}
	if(carry==0) { ch=fl.get(); }
	else 
		carry=0;
	}
	wc.pageend();
}

//************** get_comment_line() ************
void readcode::get_comment_line(char str[])
{ char ch[2]; strcpy(str,"//"); ch[1]='\0';
  ch[0]=fl.get();
  while(ch[0]!='\n')
  {   strcat(str,ch);
	  ch[0]=fl.get();
  }
}
//************** get_comment_block() ***********
void readcode::get_comment_block(char str[])
{
	char ch[2]; strcpy(str,"/*"); ch[1]='\0';
	int go=1,trace=0;
    do
	{
		ch[0]=fl.get();
		strcat(str,ch);
		if(ch[0]=='*')
		{  
		   trace=1;
		}
		else if(ch[0]=='/' && trace==1)
			go=0;
		else
			trace=0;
		
	}while(go==1);
}
//*************** get_word() ***************
char readcode::get_word(char w[],char f)
{   char ch[2]; ch[1]='\0'; strcpy(w,""); 
	ch[0]=f;
	while(isalnum(ch[0])||ch[0]=='_')
	{   strcat(w,ch);	
		ch[0]=fl.get();
	}
	//fl.putback(ch[0]);
	return ch[0];
    
}
//************ matchtype() ****************
int readcode::matchtype(char *w)
{  
   int i;	
	for(i=0;i<TYPES;i++)
	{
		if(strcmp(w,datatypes[i])==0)
		{ return T_TYPES;}
	}
	
	for(i=0;i<STATEMENTS;i++)
	{
		if(strcmp(w,statements[i])==0)
		{ return T_STATEMENTS; }
	}

	return T_NORMAL;
}

//************** issymbol() ******************

int readcode::issymbol(char ch)
{   int f=0;
	for(int i=0;i<strlen(symbols);i++)
		if(symbols[i]==ch)
			f=1;
	return f;
}
//************ get_symbol_string() **********

char readcode::get_symbol_string(char str[],char f)
{
	char ch[2]; strcpy(str,""); ch[1]='\0'; 
	ch[0]=f;
	while(issymbol(ch[0]))
	{  strcat(str,ch);
	   ch[0]=fl.get();	
	}
	//fl.putback(ch[0]);
	return ch[0];

}		

//************ get_preproc_line *************

void readcode::get_preproc_line(char str[])
{
	char ch[2]; strcpy(str,"#"); ch[1]='\0';
	ch[0]=fl.get();
	while(ch[0]!='\n')
	{
		strcat(str,ch);
		ch[0]=fl.get();
	}
	
}
//*************** get_string() ************
void readcode::get_string(char str[])	
{
	char  ch[2]; strcpy(str,"\""); ch[1]='\0';
	ch[0]=fl.get();
	while(ch[0]!='"')
	{   
		strcat(str,ch);
		if(ch[0]=='\\')
		{   ch[0]=fl.get();
			strcat(str,ch);
		}
		ch[0]=fl.get();
	}
	strcat(str,"\"");
    
}
// ************* get_constant ***********
char readcode::get_constant(char str[],char f)
{
	char ch[2]; strcpy(str,""); ch[1]='\0';
	ch[0]=f; int len=1; int hex=0;
	while(isdigit(ch[0])||
			(((ch[0]>='a' && ch[0]<='f')||(ch[0]>='A' && ch[0]<='F'))&&hex==1)) 
	{
		strcat(str,ch);
		ch[0]=fl.get();
		len++;
		if((len==2)&&((ch[0]=='x')||(ch[0]=='X'))) //if it's a hex no.
		{
			strcat(str,ch); ch[0]=fl.get(); hex=1;
		}//verification not done !!
		
	}
	return ch[0];
	
}

			
			

	

//************* writecode functions ****************
//
//************ replace() **************

void writecode::filter(char w[],char str[])
{   strcpy(str,""); char ch[2]; ch[1]='\0';
	for(int i=0;i<strlen(w);i++)
	{
		ch[0]=w[i];
		switch(ch[0])
		{
			case '<':strcat(str,"&lt;");break;
			case '>':strcat(str,"&gt;");break;
			default:strcat(str,ch);break;
		}
	}
}


void writecode::pagebegin()
{
   fl<<"<html>\n"
     <<"<!-- This page was generated by 'c2html' -->\n"
     <<"<!-- made by: Ankit Rohatgi <http://on.to/ank> -->\n"
	 <<"<!-- Please don't kill me for inserting this ! -->\n"
	 <<"<body bgcolor=\""<<C_BG<<"\" text=\""<<C_FG<<"\">\n"
	 <<"<pre>";
}

void writecode::pageend()
{
    fl<<"</pre>\n"
	  <<"</body>\n"
	  <<"</html>\n"
	  <<"<!-- Yippee !!!!!!! -->\n";
}
	 
void writecode::put_char(char ch)
{
	fl<<ch;
}

void writecode::put_word(char w[],int type)
{
	char color[3][20];
	for(int i=0;i<3;i++)
	{
		switch(type)
		{
			case T_SYMBOLS: strcpy(color[i],C_SYMBOL[i]); break;
			case T_TYPES: strcpy(color[i],C_TYPE[i]); break;
			case T_STATEMENTS: strcpy(color[i],C_STATEMENT[i]); break;
			case T_COMMENT: strcpy(color[i],C_COMMENT[i]); break;
			case T_PREPROC: strcpy(color[i],C_PREPROC[i]); break;
			case T_STRING: strcpy(color[i],C_STRING[i]); break;
			case T_CONSTANT: strcpy(color[i],C_CONSTANT[i]);break;				   			default: strcpy(color[i],C_NORMAL[i]); break;
		}
	}
	char filtered[1024];
	filter(w,filtered);
	if(strcmp(color[2],"bold")==0)
	  fl<<"<B>";
	if(strcmp(color[2],"underline")==0)
	  fl<<"<U>";
	if(strcmp(color[1],"")!=0)
	  fl<<"<span style=\"background: "<<color[1]<<"\">";
	
	fl<<"<font color=\""<<color[0]<<"\">"<<filtered<<"</font>";
	
	if(strcmp(color[1],"")!=0)
	  fl<<"</span>";
	if(strcmp(color[2],"bold")==0)
	  fl<<"</B>";
	if(strcmp(color[2],"underline")==0)
	  fl<<"</U>";
}
	
   
	

	  
	  
	
		
	

